## 后端项目下载运行

#### 前提准备

1、本地电脑已安装git、idea

#### 项目下载

使用git命令拉取gitlab上的后端工程

后端工程(gjjs-common)地址：http://114.115.138.98:8900/fukai/gjjs-common.git       

分支：master
 拉取工程操作如下，在自己新建的工作目录下右键选择Git Bash Here，在命令行使用：git clone http://114.115.138.98:8900/fukai/gjjs-common.git  命令拉取后端工程到本地目录，如图所示。
![](../assets/images/backenddownload1.png)

#### 项目运行

1、常规打开

直接从idea安装bin目录或者桌面上设置的快捷方式打开idea,然后选择刚才下载好的后端工程
 ![](../assets/images/backendopen0.png)
 ![](../assets/images/backendopen1.png)

2、通过pom.xml打开

在后端项目根目录找到pom.xml，右键打开方式选择idea打开（如果打开后遇到导入的包存在但未识别等问题，可以删除掉.idea目录）
 ![](../assets/images/backendopen2.png)

#### 切换分支
idea中切换分支至development-202206
![](../assets/images/changebranch2.png)
分支切好后自动拉取最新代码

#### 项目配置

***视频教程***

http://114.115.138.98:9497/gjjs-book/assets/videos/engineering-settings.mp4

##### 1、idea配置

 maven配置，选择本地的maven仓库和settings.xml配置文件
 ![](../assets/images/backendconfig1.png)

**注意：项目POM文件已配置远程仓库，需要在settings.xml中增加配置。**

servers元素中配置如下

```xml
<servers>
    <!-- server
     | Specifies the authentication information to use when connecting to a
    particular server, identified by
     | a unique name within the system (referred to by the
    'id' attribute below).
     |
     | NOTE: You should either specify username/password OR
    privateKey/passphrase, since these pairings are
     |       used together.
     |
    <server>
    <id>deploymentRepo</id>
      <username>repouser</username>
      <password>repopwd</password>
    </server>
    -->
    <server>
      <id>brilliance-virtual</id>
      <username>root</username>
      <password>AP5SLUTDKxS4F2RWgF297T636Hn</password>
    </server>
    <!-- Another sample, using keys to authenticate.
    <server>
      <id>siteServer</id>
    <privateKey>/path/to/private/key</privateKey>
      <passphrase>optional; leave empty if not
    used.</passphrase>
    </server>
    -->
  </servers>
```
mirrors元素中配置如下
```xml
<mirrors>
    <!-- mirror
     | Specifies a repository mirror site to use instead of a given repository. The
    repository that
     | this mirror serves has an ID that matches the mirrorOf element of this
    mirror. IDs are used
     | for inheritance and direct lookup purposes, and must be unique
    across the set of mirrors.
     |
    <mirror>
      <id>mirrorId</id>
    <mirrorOf>repositoryId</mirrorOf>
      <name>Human Readable Name for this Mirror.</name>
    <url>http://my.repository.com/repo/path</url>
    </mirror>
     -->
    <mirror>
      <id>brilliance-virtual</id>
      <mirrorOf>*</mirrorOf>
      <name>brilliance-virtual</name>
      <url>http://114.115.138.98:9620/artifactory/brilliance-virtual/</url>
    </mirror>
    <!-- <mirror>
      <id>aliyunmaven</id>
      <mirrorOf>*</mirrorOf>
      <name>阿里云公共仓库</name>
      <url>https://maven.aliyun.com/repository/public</url>
    </mirror> -->
    <!-- <mirror>
      <id>maven-default-http-blocker</id>
      <mirrorOf>external:http:*</mirrorOf>
      <name>Pseudo repository to mirror external repositories initially using HTTP.</name>
      <url>http://0.0.0.0/</url>
      <blocked>true</blocked>
    </mirror> -->
  </mirrors>
```

编译内存设置，建议根据自己电脑内存实际情况进行配置，推荐2048
 ![](../assets/images/backendconfig2.png)

##### 2、项目配置文件配置

 后端配置文件在application-work.yml，默认端口是8081，一般不用改（这里改了，前端对应后端端口位置也需要改），数据库使用的是oracle数据库，大家按照自己数据库实际地址和用户名密码进行配置
 ![](../assets/images/backendconfig3.png)

项目对应资源文件夹配置，默认在d盘的rootPath目录
 ![](../assets/images/backendconfig4.png)
 电脑d盘rootPath目录需要自己手动新建，新建好后需要把INI文件夹(文件在gjjs-common项目：gjjscommon/workroot下)

拷贝到rootPath目录
![](../assets/images/backendconfig5.png)

#### 项目编译
**注意！！！**
第一次项目搭建进行到这里，构建项目时编译会报错，因为项目之前开发的交易相关的resource、service、vo进行了提交，但manager等一些需要bd转换过来的代码没有受git管理，需要下载bdproject代码后使用bd工具编译后生成缺少的代码，可以先进行　”BD代码下载“，　“转换工具下载”　等后续流程

![](../assets/images/backendinstall1.png)

贴张图供大家理解

com.ceb.gjjs.mda包下
![](../assets/images/hdmljg1.png)

bd模型转换做完再到后端工程，如果都是老交易此时再编译项目可以正常编译通过（如果有新增交易，则需要进行相应报错代码的修改，因为bd模型工具转换成java代码后编译层面有一些无法解决的错误需要开发人员手工去改bd源码，后面开发操作指引文档会做详细说明）
![](../assets/images/backendinstall2.png)

#### 项目启动
直接运行main方法启动
如图，直接run或者debug Bt2poinnewApplication类的main方法
![](../assets/images/backendrun0.png)

